manjaro-tools/lib/util-iso.sh

616 lines
17 KiB
Bash
Raw Normal View History

2014-12-08 23:50:56 +01:00
#!/bin/bash
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
2015-06-12 03:25:28 +02:00
import ${LIBDIR}/util-iso-image.sh
import ${LIBDIR}/util-iso-boot.sh
import ${LIBDIR}/util-yaml.sh
2016-02-27 00:39:58 +01:00
error_function() {
2016-09-15 23:58:18 +02:00
if [[ -p $logpipe ]]; then
rm "$logpipe"
fi
# first exit all subshells, then print the error
if (( ! BASH_SUBSHELL )); then
error "A failure occurred in %s()." "$1"
plain "Aborting..."
fi
umount_image
exit 2
2016-02-27 00:39:58 +01:00
}
# $1: function
run_log(){
2016-09-15 23:58:18 +02:00
local func="$1"
local tmpfile=${tmp_dir}/$func.ansi.log logfile=${log_dir}/$(gen_iso_fn).$func.log
logpipe=$(mktemp -u "${tmp_dir}/$func.pipe.XXXXXXXX")
mkfifo "$logpipe"
tee "$tmpfile" < "$logpipe" &
local teepid=$!
$func &> "$logpipe"
wait $teepid
rm "$logpipe"
cat $tmpfile | perl -pe 's/\e\[?.*?[\@-~]//g' > $logfile
rm "$tmpfile"
2016-02-27 00:39:58 +01:00
}
run_safe() {
2016-09-15 23:58:18 +02:00
local restoretrap func="$1"
set -e
set -E
restoretrap=$(trap -p ERR)
trap 'error_function $func' ERR
2016-02-27 00:39:58 +01:00
2016-09-15 23:58:18 +02:00
if ${verbose};then
run_log "$func"
else
"$func"
fi
2016-02-27 00:39:58 +01:00
2016-09-15 23:58:18 +02:00
eval $restoretrap
set +E
set +e
2016-02-27 00:39:58 +01:00
}
2016-06-13 21:48:41 +02:00
trap_exit() {
2016-09-15 23:58:18 +02:00
local sig=$1; shift
error "$@"
umount_image
trap -- "$sig"
kill "-$sig" "$$"
2016-06-13 21:48:41 +02:00
}
make_sig () {
msg2 "Creating signature file..."
cd "$1"
gpg --detach-sign --default-key ${gpg_key} $2.sfs
cd ${OLDPWD}
2016-10-19 16:01:16 +02:00
}
# $1: file
make_checksum(){
msg2 "Creating md5sum ..."
cd $1
md5sum $2.sfs > $2.md5
cd ${OLDPWD}
}
2015-05-11 12:47:02 +02:00
# $1: image path
make_sfs() {
2016-10-13 15:24:31 +02:00
local src="$1"
if [[ ! -e "${src}" ]]; then
error "The path %s does not exist" "${src}"
retrun 1
2016-09-15 23:58:18 +02:00
fi
local timer=$(get_timer) dest=${iso_root}/${iso_name}/${target_arch}
2016-09-15 23:58:18 +02:00
local name=${1##*/}
2016-10-13 15:24:31 +02:00
local sfs="${dest}/${name}.sfs"
mkdir -p ${dest}
2016-10-13 15:24:31 +02:00
msg "Generating SquashFS image for %s" "${src}"
if [[ -f "${sfs}" ]]; then
local has_changed_dir=$(find ${src} -newer ${sfs})
msg2 "Possible changes for %s ..." "${src}" >> ${tmp_dir}/buildiso.debug
2016-09-15 23:58:18 +02:00
msg2 "%s" "${has_changed_dir}" >> ${tmp_dir}/buildiso.debug
if [[ -n "${has_changed_dir}" ]]; then
2016-10-13 15:24:31 +02:00
msg2 "SquashFS image %s is not up to date, rebuilding..." "${sfs}"
rm "${sfs}"
2016-09-15 23:58:18 +02:00
else
2016-10-13 15:24:31 +02:00
msg2 "SquashFS image %s is up to date, skipping." "${sfs}"
2016-09-15 23:58:18 +02:00
return
fi
fi
if ${persist};then
local size=32G
local mnt="${mnt_dir}/${name}"
msg2 "Creating ext4 image of %s ..." "${size}"
truncate -s ${size} "${src}.img"
local ext4_args=()
${verbose} && ext4_args+=(-q)
ext4_args+=(-O ^has_journal,^resize_inode -E lazy_itable_init=0 -m 0)
mkfs.ext4 ${ext4_args[@]} -F "${src}.img" &>/dev/null
tune2fs -c 0 -i 0 "${src}.img" &> /dev/null
mount_img "${work_dir}/${name}.img" "${mnt}"
msg2 "Copying %s ..." "${src}/"
cp -aT "${src}/" "${mnt}/"
umount_img "${mnt}"
fi
2016-10-13 15:24:31 +02:00
msg2 "Creating SquashFS image, this may take some time..."
local used_kernel=${kernel:5:1} mksfs_args=()
if ${persist};then
mksfs_args+=(${work_dir}/${name}.img)
else
mksfs_args+=(${src})
fi
mksfs_args+=(${sfs} -noappend)
2016-10-19 16:01:16 +02:00
local highcomp="-b 256K -Xbcj x86" comp='xz'
2016-09-15 23:58:18 +02:00
if [[ "${name}" == "mhwdfs" && ${used_kernel} < "4" ]]; then
mksfs_args+=(-comp lz4)
2016-09-15 23:58:18 +02:00
else
2016-10-19 16:01:16 +02:00
mksfs_args+=(-comp ${comp} ${highcomp})
fi
if ${verbose};then
mksquashfs "${mksfs_args[@]}" >/dev/null
else
mksquashfs "${mksfs_args[@]}"
2016-09-15 23:58:18 +02:00
fi
2016-10-19 16:01:16 +02:00
make_checksum "${dest}" "${name}"
2016-10-13 15:24:31 +02:00
${persist} && rm "${src}.img"
2016-09-15 23:58:18 +02:00
show_elapsed_time "${FUNCNAME}" "${timer_start}"
2015-05-11 12:47:02 +02:00
}
2016-02-26 16:09:34 +01:00
assemble_iso(){
2016-09-15 23:58:18 +02:00
msg "Creating ISO image..."
local efi_boot_args=()
if [[ -f "${iso_root}/EFI/miso/efiboot.img" ]]; then
2016-09-15 23:58:18 +02:00
msg2 "Setting efi args. El Torito detected."
efi_boot_args=("-eltorito-alt-boot"
"-e EFI/miso/efiboot.img"
2016-09-15 23:58:18 +02:00
"-isohybrid-gpt-basdat"
"-no-emul-boot")
fi
xorriso -as mkisofs \
-iso-level 3 -rock -joliet \
-max-iso9660-filenames -omit-period \
-omit-version-number \
-relaxed-filenames -allow-lowercase \
-volid "${iso_label}" \
-appid "${iso_app_id}" \
-publisher "${iso_publisher}" \
-preparer "Prepared by manjaro-tools/${0##*/}" \
-eltorito-boot isolinux/isolinux.bin \
-eltorito-catalog isolinux/boot.cat \
2016-09-15 23:58:18 +02:00
-no-emul-boot -boot-load-size 4 -boot-info-table \
-isohybrid-mbr "${iso_root}/isolinux/isohdpfx.bin" \
2016-09-15 23:58:18 +02:00
${efi_boot_args[@]} \
-output "${iso_dir}/${iso_file}" \
"${iso_root}/"
}
# Build ISO
make_iso() {
2016-09-15 23:58:18 +02:00
msg "Start [Build ISO]"
touch "${iso_root}/.miso"
for sfs_dir in $(find "${work_dir}" -maxdepth 1 -type d); do
2016-10-13 15:24:31 +02:00
if [[ "${sfs_dir}" != "${work_dir}" ]]; then
make_sfs "${sfs_dir}"
2016-09-15 23:58:18 +02:00
fi
done
msg "Making bootable image"
# Sanity checks
[[ ! -d "${iso_root}" ]] && return 1
2016-09-15 23:58:18 +02:00
if [[ -f "${iso_dir}/${iso_file}" ]]; then
msg2 "Removing existing bootable image..."
rm -rf "${iso_dir}/${iso_file}"
fi
assemble_iso
msg "Done [Build ISO]"
}
2016-02-18 22:02:01 +01:00
gen_iso_fn(){
2016-09-15 23:58:18 +02:00
local vars=() name
vars+=("${iso_name}")
if ! ${chrootcfg};then
2016-09-15 23:58:18 +02:00
[[ -n ${profile} ]] && vars+=("${profile}")
fi
[[ ${initsys} == 'openrc' ]] && vars+=("${initsys}")
vars+=("${dist_release}")
vars+=("${target_branch}")
vars+=("${target_arch}")
for n in ${vars[@]};do
name=${name:-}${name:+-}${n}
done
echo $name
2016-02-18 22:02:01 +01:00
}
2016-05-21 00:05:49 +02:00
reset_pac_conf(){
2016-09-15 23:58:18 +02:00
info "Restoring [%s/etc/pacman.conf] ..." "$1"
sed -e 's|^.*HoldPkg.*|HoldPkg = pacman glibc manjaro-system|' \
-e "s|^.*#CheckSpace|CheckSpace|" \
-i "$1/etc/pacman.conf"
2016-05-21 00:05:49 +02:00
}
# Base installation (rootfs)
2015-01-13 04:48:04 +01:00
make_image_root() {
2016-09-15 23:58:18 +02:00
if [[ ! -e ${work_dir}/build.${FUNCNAME} ]]; then
msg "Prepare [Base installation] (rootfs)"
local path="${work_dir}/rootfs"
2016-09-15 23:58:18 +02:00
mkdir -p ${path}
2015-06-29 04:08:45 +02:00
2016-09-15 23:58:18 +02:00
chroot_create "${path}" "${packages}" || die
2015-06-29 04:08:45 +02:00
pacman -Qr "${path}" > "${path}/rootfs-pkgs.txt"
2016-09-15 23:58:18 +02:00
copy_overlay "${profile_dir}/root-overlay" "${path}"
2016-05-20 19:42:16 +02:00
prepare_initcpio "${path}"
2016-09-15 23:58:18 +02:00
reset_pac_conf "${path}"
2016-05-20 19:42:16 +02:00
2016-09-15 23:58:18 +02:00
clean_up_image "${path}"
: > ${work_dir}/build.${FUNCNAME}
msg "Done [Base installation] (rootfs)"
2016-09-15 23:58:18 +02:00
fi
2014-12-10 19:06:52 +01:00
}
2016-10-12 12:32:54 +02:00
make_image_desktop() {
2016-09-15 23:58:18 +02:00
if [[ ! -e ${work_dir}/build.${FUNCNAME} ]]; then
2016-10-11 17:56:23 +02:00
msg "Prepare [Desktop installation] (desktopfs)"
local path="${work_dir}/desktopfs"
2016-09-15 23:58:18 +02:00
mkdir -p ${path}
2016-09-15 23:58:18 +02:00
mount_image "${path}"
2016-09-15 23:58:18 +02:00
chroot_create "${path}" "${packages}"
2015-06-29 04:08:45 +02:00
2016-10-11 17:56:23 +02:00
pacman -Qr "${path}" > "${path}/desktopfs-pkgs.txt"
cp "${path}/desktopfs-pkgs.txt" ${iso_dir}/$(gen_iso_fn)-pkgs.txt
[[ -e ${profile_dir}/desktop-overlay ]] && copy_overlay "${profile_dir}/desktop-overlay" "${path}"
2016-09-15 23:58:18 +02:00
reset_pac_conf "${path}"
2016-05-20 19:42:16 +02:00
2016-09-15 23:58:18 +02:00
umount_image
clean_up_image "${path}"
: > ${work_dir}/build.${FUNCNAME}
2016-10-11 17:56:23 +02:00
msg "Done [Desktop installation] (desktopfs)"
2016-09-15 23:58:18 +02:00
fi
2016-02-25 15:51:25 +01:00
}
mount_image_select(){
if [[ -f "${packages_desktop}" ]]; then
2016-09-15 23:58:18 +02:00
mount_image_custom "$1"
else
mount_image "$1"
fi
2014-12-08 23:50:56 +01:00
}
2015-12-18 18:25:13 +01:00
make_image_live() {
2016-09-15 23:58:18 +02:00
if [[ ! -e ${work_dir}/build.${FUNCNAME} ]]; then
msg "Prepare [Live installation] (livefs)"
local path="${work_dir}/livefs"
2016-09-15 23:58:18 +02:00
mkdir -p ${path}
2016-09-15 23:58:18 +02:00
mount_image_select "${path}"
2016-09-15 23:58:18 +02:00
chroot_create "${path}" "${packages}"
2015-06-29 04:08:45 +02:00
pacman -Qr "${path}" > "${path}/livefs-pkgs.txt"
2016-09-15 23:58:18 +02:00
copy_overlay "${profile_dir}/live-overlay" "${path}"
configure_live_image "${path}"
2016-09-15 23:58:18 +02:00
reset_pac_conf "${path}"
2016-05-20 19:42:16 +02:00
2016-09-15 23:58:18 +02:00
umount_image
2016-09-15 23:58:18 +02:00
# Clean up GnuPG keys
rm -rf "${path}/etc/pacman.d/gnupg"
clean_up_image "${path}"
: > ${work_dir}/build.${FUNCNAME}
msg "Done [Live installation] (livefs)"
2016-09-15 23:58:18 +02:00
fi
2014-12-15 23:12:04 +01:00
}
make_image_mhwd() {
2016-09-15 23:58:18 +02:00
if [[ ! -e ${work_dir}/build.${FUNCNAME} ]]; then
msg "Prepare [drivers repository] (mhwdfs)"
local path="${work_dir}/mhwdfs"
2016-09-15 23:58:18 +02:00
mkdir -p ${path}${mhwd_repo}
2016-09-15 23:58:18 +02:00
mount_image_select "${path}"
2015-06-29 04:08:45 +02:00
2016-09-15 23:58:18 +02:00
reset_pac_conf "${path}"
2016-05-20 19:42:16 +02:00
2016-09-15 23:58:18 +02:00
copy_from_cache "${path}" "${packages}"
2015-07-04 12:09:39 +02:00
2016-09-15 23:58:18 +02:00
if [[ -n "${packages_cleanup}" ]]; then
for mhwd_clean in ${packages_cleanup}; do
rm ${path}${mhwd_repo}/${mhwd_clean}
done
fi
cp ${DATADIR}/pacman-mhwd.conf ${path}/opt
make_repo "${path}"
configure_mhwd_drivers "${path}"
2016-09-15 23:58:18 +02:00
umount_image
clean_up_image "${path}"
: > ${work_dir}/build.${FUNCNAME}
msg "Done [drivers repository] (mhwdfs)"
2016-09-15 23:58:18 +02:00
fi
2014-12-08 23:50:56 +01:00
}
2015-01-13 04:48:04 +01:00
make_image_boot() {
2016-09-15 23:58:18 +02:00
if [[ ! -e ${work_dir}/build.${FUNCNAME} ]]; then
msg "Prepare [/iso/%s/boot]" "${iso_name}"
2016-10-12 12:32:54 +02:00
local boot="${iso_root}/${iso_name}/boot"
mkdir -p ${boot}/${target_arch}
cp ${work_dir}/rootfs/boot/vmlinuz* ${boot}/${target_arch}/vmlinuz
local path="${work_dir}/bootfs"
2016-09-15 23:58:18 +02:00
mkdir -p ${path}
2015-06-25 09:59:35 +02:00
mount_image_live "${path}"
2016-09-15 23:58:18 +02:00
configure_plymouth "${path}"
2015-06-25 09:59:35 +02:00
# if [[ ${gpg_key} ]]; then
# gpg --export ${gpg_key} >${work_dir}/gpgkey
# exec 17<>${work_dir}/gpgkey
# fi
# MISO_GNUPG_FD=${gpg_key:+17}
prepare_initramfs "${profile_dir}" "${path}"
2015-06-29 04:08:45 +02:00
# if [[ ${gpg_key} ]]; then
# exec 17<&-
# fi
2015-06-29 04:08:45 +02:00
2016-10-12 12:32:54 +02:00
mv ${path}/boot/initramfs.img ${boot}/${target_arch}/initramfs.img
prepare_boot_extras "${path}" "${boot}"
2015-06-25 09:59:35 +02:00
2016-09-15 23:58:18 +02:00
umount_image
2015-06-25 09:59:35 +02:00
2016-09-15 23:58:18 +02:00
rm -R ${path}
: > ${work_dir}/build.${FUNCNAME}
msg "Done [/iso/%s/boot]" "${iso_name}"
2016-09-15 23:58:18 +02:00
fi
2014-12-08 23:50:56 +01:00
}
# Prepare /EFI
2016-10-06 20:53:10 +02:00
make_efi_usb() {
2016-09-15 23:58:18 +02:00
if [[ ! -e ${work_dir}/build.${FUNCNAME} ]]; then
msg "Prepare [/iso/EFI]"
prepare_efi_loader "${work_dir}/livefs" "${iso_root}" "usb"
2016-09-15 23:58:18 +02:00
: > ${work_dir}/build.${FUNCNAME}
msg "Done [/iso/EFI]"
2016-09-15 23:58:18 +02:00
fi
2014-12-08 23:50:56 +01:00
}
# Prepare kernel.img::/EFI for "El Torito" EFI boot mode
2016-10-06 20:53:10 +02:00
make_efi_dvd() {
2016-09-15 23:58:18 +02:00
if [[ ! -e ${work_dir}/build.${FUNCNAME} ]]; then
msg "Prepare [/efiboot/EFI]"
2016-10-13 15:24:31 +02:00
local src="${iso_root}/EFI/miso"
mkdir -p "${src}"
local size=31M
local mnt="${mnt_dir}/efiboot" img="${src}/efiboot.img"
${pxe_boot} && size=40M
msg2 "Creating fat image of %s ..." "${size}"
truncate -s ${size} "${img}"
mkfs.fat -n MISO_EFI "${img}" &>/dev/null
mkdir -p "${mnt}"
mount_img "${img}" "${mnt}"
prepare_efiboot_image "${mnt}" "${iso_root}"
prepare_efi_loader "${work_dir}/livefs" "${mnt}" "dvd"
umount_img "${mnt}"
2016-10-13 15:24:31 +02:00
2016-09-15 23:58:18 +02:00
: > ${work_dir}/build.${FUNCNAME}
msg "Done [/efiboot/EFI]"
2016-09-15 23:58:18 +02:00
fi
2014-12-08 23:50:56 +01:00
}
make_isolinux() {
if [[ ! -e ${work_dir}/build.${FUNCNAME} ]]; then
msg "Prepare [/iso/isolinux]"
local isolinux=${iso_root}/isolinux
mkdir -p ${isolinux}
prepare_isolinux "${work_dir}/livefs" "${isolinux}"
: > ${work_dir}/build.${FUNCNAME}
msg "Done [/iso/isolinux]"
fi
}
make_syslinux() {
if [[ ! -e ${work_dir}/build.${FUNCNAME} ]]; then
msg "Prepare [/iso/${iso_name}/boot/syslinux]"
local syslinux=${iso_root}/${iso_name}/boot/syslinux
2016-10-08 21:22:32 +02:00
mkdir -p ${syslinux}
prepare_syslinux "${work_dir}/livefs" "${syslinux}"
2016-10-08 21:22:32 +02:00
mkdir -p ${syslinux}/hdt
2016-10-12 12:32:54 +02:00
# gzip -c -9 ${work_dir}/rootfs/usr/share/hwdata/pci.ids > ${syslinux}/hdt/pciids.gz
# gzip -c -9 ${work_dir}/livefs/usr/lib/modules/*-MANJARO/modules.alias > ${syslinux}/hdt/modalias.gz
: > ${work_dir}/build.${FUNCNAME}
msg "Done [/iso/${iso_name}/boot/syslinux]"
fi
}
check_requirements(){
2016-09-15 23:58:18 +02:00
[[ -f ${run_dir}/.buildiso ]] || die "%s is not a valid iso profiles directory!" "${run_dir}"
if ! $(is_valid_arch_iso ${target_arch});then
die "%s is not a valid arch!" "${target_arch}"
fi
if ! $(is_valid_branch ${target_branch});then
die "%s is not a valid branch!" "${target_branch}"
fi
2016-09-15 23:58:18 +02:00
if ! is_valid_init "${initsys}";then
die "%s is not a valid init system!" "${initsys}"
fi
2016-09-15 23:58:18 +02:00
local iso_kernel=${kernel:5:1} host_kernel=$(uname -r)
2016-09-15 23:58:18 +02:00
if [[ ${iso_kernel} < "4" ]] || [[ ${host_kernel%%*.} < "4" ]];then
use_overlayfs='false'
fi
2016-09-15 23:58:18 +02:00
if ${use_overlayfs};then
iso_fs="overlayfs"
else
iso_fs="aufs"
fi
import ${LIBDIR}/util-iso-${iso_fs}.sh
}
2016-02-22 19:24:49 +01:00
make_torrent(){
2016-09-15 23:58:18 +02:00
local fn=${iso_file}.torrent
msg2 "Creating (%s) ..." "${fn}"
[[ -f ${iso_dir}/${fn} ]] && rm ${iso_dir}/${fn}
mktorrent ${mktorrent_args[*]} -o ${iso_dir}/${fn} ${iso_dir}/${iso_file}
}
2014-12-31 01:02:43 +01:00
compress_images(){
2016-09-15 23:58:18 +02:00
local timer=$(get_timer)
run_safe "make_iso"
${torrent} && make_torrent
user_own "${iso_dir}" "-R"
show_elapsed_time "${FUNCNAME}" "${timer}"
2014-12-31 01:02:43 +01:00
}
# prepare_boot_loaders(){
# local timer=$(get_timer)
# run_safe "make_image_boot"
# run_safe "make_isolinux"
# run_safe "make_syslinux"
# if [[ "${target_arch}" == "x86_64" ]]; then
# run_safe "make_efi_usb"
# run_safe "make_efi_dvd"
# fi
# show_elapsed_time "${FUNCNAME}" "${timer}"
# }
2016-02-25 06:40:39 +01:00
prepare_images(){
2016-09-15 23:58:18 +02:00
local timer=$(get_timer)
load_pkgs "${profile_dir}/Packages-Root"
run_safe "make_image_root"
if [[ -f "${packages_desktop}" ]] ; then
load_pkgs "${packages_desktop}"
2016-10-12 12:32:54 +02:00
run_safe "make_image_desktop"
2016-09-15 23:58:18 +02:00
fi
if [[ -f ${profile_dir}/Packages-Live ]]; then
load_pkgs "${profile_dir}/Packages-Live"
run_safe "make_image_live"
fi
if [[ -f ${packages_mhwd} ]] ; then
load_pkgs "${packages_mhwd}"
run_safe "make_image_mhwd"
fi
run_safe "make_image_boot"
run_safe "make_isolinux"
run_safe "make_syslinux"
if [[ "${target_arch}" == "x86_64" ]]; then
run_safe "make_efi_usb"
run_safe "make_efi_dvd"
fi
2016-09-15 23:58:18 +02:00
show_elapsed_time "${FUNCNAME}" "${timer}"
}
archive_logs(){
local name=$(gen_iso_fn) ext=log.tar.xz src=${tmp_dir}/archives.list
find ${log_dir} -maxdepth 1 -name "$name*.log" -printf "%f\n" > $src
msg2 "Archiving log files [%s] ..." "$name.$ext"
tar -cJf ${log_dir}/$name.$ext -C ${log_dir} -T $src
msg2 "Cleaning log files ..."
find ${log_dir} -maxdepth 1 -name "$name*.log" -delete
}
make_profile(){
2016-09-15 23:58:18 +02:00
msg "Start building [%s]" "${profile}"
${clean_first} && chroot_clean "${work_dir}" "${iso_root}"
2016-09-15 23:58:18 +02:00
if ${iso_only}; then
[[ ! -d ${work_dir} ]] && die "Create images: buildiso -p %s -x" "${profile}"
compress_images
${verbose} && archive_logs
exit 1
fi
# if ${boot_only}; then
# prepare_boot_loaders
# exit 1
# fi
2016-09-15 23:58:18 +02:00
if ${images_only}; then
prepare_images
${verbose} && archive_logs
warning "Continue compress: buildiso -p %s -zc ..." "${profile}"
exit 1
else
prepare_images
compress_images
${verbose} && archive_logs
fi
reset_profile
msg "Finished building [%s]" "${profile}"
show_elapsed_time "${FUNCNAME}" "${timer_start}"
}
2016-02-25 06:40:39 +01:00
2016-06-09 12:49:28 +02:00
get_pacman_conf(){
2016-09-15 23:58:18 +02:00
local user_conf=${profile_dir}/user-repos.conf pac_arch='default' conf
[[ "${target_arch}" == 'x86_64' ]] && pac_arch='multilib'
if [[ -f ${user_conf} ]];then
info "detected: %s" "user-repos.conf"
check_user_repos_conf "${user_conf}"
conf=${tmp_dir}/custom-pacman.conf
cat ${DATADIR}/pacman-$pac_arch.conf ${user_conf} > "$conf"
else
conf="${DATADIR}/pacman-$pac_arch.conf"
fi
echo "$conf"
}
gen_webseed(){
2016-09-15 23:58:18 +02:00
local webseed url project=$(get_project "${edition}")
url=${host}/project/${project}/${dist_release}/${profile}/${iso_file}
local mirrors=('heanet' 'jaist' 'netcologne' 'iweb' 'kent')
2016-09-15 23:58:18 +02:00
for m in ${mirrors[@]};do
webseed=${webseed:-}${webseed:+,}"http://${m}.dl.${url}"
done
echo ${webseed}
}
2016-02-25 06:40:39 +01:00
load_profile(){
2016-09-15 23:58:18 +02:00
conf="${profile_dir}/profile.conf"
2016-09-15 23:58:18 +02:00
info "Profile: [%s]" "${profile}"
2016-02-25 06:40:39 +01:00
2016-09-15 23:58:18 +02:00
load_profile_config "$conf"
2016-02-25 06:40:39 +01:00
2016-09-15 23:58:18 +02:00
pacman_conf=$(get_pacman_conf)
2016-09-15 23:58:18 +02:00
mirrors_conf=$(get_pac_mirrors_conf "${target_branch}")
2016-06-10 11:55:41 +02:00
2016-09-15 23:58:18 +02:00
iso_file=$(gen_iso_fn).iso
2016-02-25 06:40:39 +01:00
2016-09-15 23:58:18 +02:00
mkchroot_args+=(-C ${pacman_conf} -S ${mirrors_conf} -B "${build_mirror}/${target_branch}" -K)
work_dir=${chroots_iso}/${profile}/${target_arch}
2016-02-25 06:40:39 +01:00
2016-09-15 23:58:18 +02:00
iso_dir="${cache_dir_iso}/${edition}/${dist_release}/${profile}"
2016-02-25 06:40:39 +01:00
iso_root=${chroots_iso}/${profile}/iso
2016-10-13 15:24:31 +02:00
mnt_dir=${chroots_iso}/${profile}/mnt
prepare_dir "${mnt_dir}"
2016-09-15 23:58:18 +02:00
prepare_dir "${iso_dir}"
user_own "${iso_dir}"
2016-09-15 23:58:18 +02:00
mktorrent_args=(-v -p -l ${piece_size} -a ${tracker_url} -w $(gen_webseed))
2016-02-25 06:40:39 +01:00
}
prepare_profile(){
2016-09-15 23:58:18 +02:00
profile=$1
edition=$(get_edition ${profile})
profile_dir=${run_dir}/${edition}/${profile}
check_profile
load_profile
2016-02-25 06:40:39 +01:00
}
build(){
2016-09-15 23:58:18 +02:00
prepare_profile "$1"
make_profile
2016-02-25 06:40:39 +01:00
}